com.fasterxml.jackson.databind.deser

## Class SettableBeanProperty.Delegating

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase
  - - com.fasterxml.jackson.databind.deser.SettableBeanProperty
    - - com.fasterxml.jackson.databind.deser.SettableBeanProperty.Delegating

- All Implemented Interfaces:
    BeanProperty, Named, Serializable
  Direct Known Subclasses:
    InnerClassProperty, ManagedReferenceProperty, MergingSettableBeanProperty
  Enclosing class:
    SettableBeanProperty

      public abstract static class SettableBeanProperty.Delegating
      extends SettableBeanProperty

  Helper class that is designed to both make it easier to sub-class delegating subtypes and to reduce likelihood of breakage when new methods are added.

  Class was specifically added to help with `Afterburner` module, but its use is not limited to only support it.

  Since:
    2.9
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `SettableBeanProperty.Delegating`

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `BeanProperty.Bogus, BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SettableBeanProperty` | `delegate`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _nullProvider, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

    - ### Fields inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `_aliases, _metadata, _propertyFormat`

    - ### Fields inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `EMPTY_FORMAT, EMPTY_INCLUDE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Delegating(SettableBeanProperty d)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected SettableBeanProperty` | `_with(SettableBeanProperty newDelegate)`
    `void` | `assignIndex(int index)` Method used to assign index for property.
    `void` | `deserializeAndSet(JsonParser p, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `Object` | `deserializeSetAndReturn(JsonParser p, DeserializationContext ctxt, Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
    `void` | `fixAccess(DeserializationConfig config)` Method called to ensure that the mutator has proper access rights to be called, as per configuration.
    `<A extends Annotation> A` | `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `int` | `getCreatorIndex()` Method for accessing index of the creator property: for other types of properties will simply return -1.
    `protected Class<?>` | `getDeclaringClass()`
    `SettableBeanProperty` | `getDelegate()`
    `Object` | `getInjectableValueId()` Accessor for id of injectable value, if this bean property supports value injection.
    `String` | `getManagedReferenceName()`
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `ObjectIdInfo` | `getObjectIdInfo()`
    `int` | `getPropertyIndex()` Method for accessing unique index of this property; indexes are assigned once all properties of a `BeanDeserializer` have been collected.
    `JsonDeserializer<Object>` | `getValueDeserializer()`
    `TypeDeserializer` | `getValueTypeDeserializer()`
    `boolean` | `hasValueDeserializer()`
    `boolean` | `hasValueTypeDeserializer()`
    `boolean` | `hasViews()`
    `void` | `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
    `Object` | `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
    `boolean` | `visibleInView(Class<?> activeView)`
    `protected abstract SettableBeanProperty` | `withDelegate(SettableBeanProperty d)` Method sub-classes must implement, to construct a new instance with given delegate.
    `SettableBeanProperty` | `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
    `SettableBeanProperty` | `withNullProvider(NullValueProvider nva)`
    `SettableBeanProperty` | `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, _throwAsIOE, _throwAsIOE, depositSchemaProperty, deserialize, deserializeWith, getContextAnnotation, getFullName, getName, getNullValueProvider, getType, getWrapperName, isIgnorable, markAsIgnorable, setManagedReferenceName, setObjectIdInfo, setViews, toString, withSimpleName`

    - ### Methods inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `findAliases, findFormatOverrides, findPropertyFormat, findPropertyInclusion, getMetadata, isRequired, isVirtual`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### delegate

          protected final SettableBeanProperty delegate

  - ### Constructor Detail

    - #### Delegating

          protected Delegating(SettableBeanProperty d)

  - ### Method Detail

    - #### withDelegate

          protected abstract SettableBeanProperty withDelegate(SettableBeanProperty d)

      Method sub-classes must implement, to construct a new instance with given delegate.

    - #### _with

          protected SettableBeanProperty _with(SettableBeanProperty newDelegate)

    - #### withValueDeserializer

          public SettableBeanProperty withValueDeserializer(JsonDeserializer<?> deser)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`
      Parameters:
        `deser` - Deserializer to assign to the new property instance
      Returns:
        Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

    - #### withName

          public SettableBeanProperty withName(PropertyName newName)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withName` in class `SettableBeanProperty`
      Parameters:
        `newName` - Name to use for the new instance.
      Returns:
        Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

    - #### withNullProvider

          public SettableBeanProperty withNullProvider(NullValueProvider nva)

      Specified by:
        `withNullProvider` in class `SettableBeanProperty`

    - #### assignIndex

          public void assignIndex(int index)

      Description copied from class: `SettableBeanProperty`
      Method used to assign index for property.
      Overrides:
        `assignIndex` in class `SettableBeanProperty`

    - #### fixAccess

          public void fixAccess(DeserializationConfig config)

      Description copied from class: `SettableBeanProperty`
      Method called to ensure that the mutator has proper access rights to be called, as per configuration. Overridden by implementations that have mutators that require access, fields and setters.
      Overrides:
        `fixAccess` in class `SettableBeanProperty`

    - #### getDeclaringClass

          protected Class<?> getDeclaringClass()

      Overrides:
        `getDeclaringClass` in class `SettableBeanProperty`

    - #### getManagedReferenceName

          public String getManagedReferenceName()

      Overrides:
        `getManagedReferenceName` in class `SettableBeanProperty`

    - #### getObjectIdInfo

          public ObjectIdInfo getObjectIdInfo()

      Overrides:
        `getObjectIdInfo` in class `SettableBeanProperty`

    - #### hasValueDeserializer

          public boolean hasValueDeserializer()

      Overrides:
        `hasValueDeserializer` in class `SettableBeanProperty`

    - #### hasValueTypeDeserializer

          public boolean hasValueTypeDeserializer()

      Overrides:
        `hasValueTypeDeserializer` in class `SettableBeanProperty`

    - #### getValueDeserializer

          public JsonDeserializer<Object> getValueDeserializer()

      Overrides:
        `getValueDeserializer` in class `SettableBeanProperty`

    - #### getValueTypeDeserializer

          public TypeDeserializer getValueTypeDeserializer()

      Overrides:
        `getValueTypeDeserializer` in class `SettableBeanProperty`

    - #### visibleInView

          public boolean visibleInView(Class<?> activeView)

      Overrides:
        `visibleInView` in class `SettableBeanProperty`

    - #### hasViews

          public boolean hasViews()

      Overrides:
        `hasViews` in class `SettableBeanProperty`

    - #### getPropertyIndex

          public int getPropertyIndex()

      Description copied from class: `SettableBeanProperty`
      Method for accessing unique index of this property; indexes are assigned once all properties of a `BeanDeserializer` have been collected.
      Overrides:
        `getPropertyIndex` in class `SettableBeanProperty`
      Returns:
        Index of this property

    - #### getCreatorIndex

          public int getCreatorIndex()

      Description copied from class: `SettableBeanProperty`
      Method for accessing index of the creator property: for other types of properties will simply return -1.
      Overrides:
        `getCreatorIndex` in class `SettableBeanProperty`

    - #### getInjectableValueId

          public Object getInjectableValueId()

      Description copied from class: `SettableBeanProperty`
      Accessor for id of injectable value, if this bean property supports value injection.
      Overrides:
        `getInjectableValueId` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### getAnnotation

          public <A extends Annotation> A getAnnotation(Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

      Note that this method should only be called for custom annotations; access to standard Jackson annotations (or ones supported by alternate `AnnotationIntrospector`s) should be accessed through `AnnotationIntrospector`.

      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getDelegate

          public SettableBeanProperty getDelegate()

    - #### deserializeAndSet

          public void deserializeAndSet(JsonParser p,
                                        DeserializationContext ctxt,
                                        Object instance)
                                 throws IOException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `IOException`

    - #### deserializeSetAndReturn

          public Object deserializeSetAndReturn(JsonParser p,
                                                DeserializationContext ctxt,
                                                Object instance)
                                         throws IOException

      Description copied from class: `SettableBeanProperty`
      Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.
      Specified by:
        `deserializeSetAndReturn` in class `SettableBeanProperty`
      Throws:
        `IOException`

    - #### set

          public void set(Object instance,
                          Object value)
                   throws IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object.

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `IOException`

    - #### setAndReturn

          public Object setAndReturn(Object instance,
                                     Object value)
                              throws IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `setAndReturn` in class `SettableBeanProperty`
      Throws:
        `IOException`

Copyright © 2008–2018 FasterXML. All rights reserved.